rm(list=ls())

dir <- "C:\\"
####### set you own folder !!!!!

setwd(dir)
source("NLCUB.r")

# simulate RATING DATA
set.seed(1234567)
N <- 1000
pai.sim <- 0.8
xi.sim <- 0.3
g.sim <- c(1,1,2,4,2)
cats <-5


dati<-simul(N,pai.sim,xi.sim,g.sim) 
datitab <- as.matrix(table(dati)) #type matrix not necessary


#######################################
#            NLCUB model              #
#######################################

############# estimation with fixed g and EM (default)
est<-NLCUB(datitab,g=g.sim,freq.table=TRUE)
est

est<-NLCUB(dati,g=g.sim,freq.table=FALSE)
est

# to estimate a CUB model, set g=c(1,1,1,1,1)

est<-NLCUB(dati,g=c(1,1,1,1,1),freq.table=FALSE)
est


############# estimation with model selection
est<-NLCUB(datitab,m=cats,freq.table=TRUE,method='EM')
est

postscript(file="NLCUB.ps",width=9,height=5,paper='special',horizontal=F)
est<-NLCUB(datitab,m=cats,freq.table=TRUE,method='EM')
dev.off()

est<-NLCUB(dati,m=cats,freq.table=FALSE,method='EM')
est

#est<-NLCUB(datitab,m=cats,freq.table=TRUE,method='CV',cv.fold=5)
#est

#est<-NLCUB(dati,m=cats,freq.table=FALSE,method='CV',cv.fold=5)
#est


pai<-est$pai
xi<-est$csi
g<-est$g
################################# SINGLE FUNCTIONS

############Estimation fixed g
estg <- MaxLikNLCUB.fix.g(datitab,g.sim,c(0.5,0.5))
estg

estg <- EM.NLCUB.fix.g(datitab,g.sim,c(0.5,0.5),tolerEM=0.000000001,maxiterEM=500)
estg


############Computation of fitted frequencies and Br
ff<-thfr(pai,xi,g)

############Computation of the dissimilarity index
diss<-dissNLCUB(datitab,pai,xi,g,freq.table=TRUE)
diss

diss<-dissNLCUB(dati,pai,xi,g,freq.table=FALSE)
diss

############  Computation of
############  $transition_probability_matrix (if print.matrix=TRUE)
############  $transition_probabilities 				
############  $unconditioned_transition_probability
############  $expected_number_one.rating.point_increments

pt<-probtrans(xi,g,print.matrix=TRUE)
pt

############Observed vs. fitted frequencies plot
NLCUBplot(datitab,pai,xi,g,freq.table=TRUE)

############Transition plot
transplot(xi,g,log.scale=TRUE)


